function amazonSig(JSONData) {
    MyObject = {
        res: null,
        err: null
    };

    try {
        var CryptoJS = require("crypto-js");

        var data1s = JSON.parse(JSONData);

        var kDate = CryptoJS.HmacSHA256(data1s.dateStamp, "AWS4" + data1s.key);
        var kRegion = CryptoJS.HmacSHA256(data1s.regionName, kDate);
        var kService = CryptoJS.HmacSHA256(data1s.serviceName, kRegion);
        var kSigning = CryptoJS.HmacSHA256("aws4_request", kService);
        var kSignature = CryptoJS.HmacSHA256(data1s.stringToSign, kSigning);

        MyObject.res = kSignature.toString(CryptoJS.enc.Hex);

    } catch (e) {
        MyObject.err = e.toString();
    }

    return  MyObject;
}

var http = require("http");

http.createServer(function(request, response){
    const { headers, method, url } = request;
    let body = [];

    // Устанавливаем заголовки
    response.setHeader('Content-Type', 'application/json');

    request.on('error', (err) => {
        console.error(err);
        response.statusCode = 404;
    }).on('data', (chunk) => {
        // Получаем тело запроса
        body.push(chunk);
    }).on('end', () => {
        // Преобразуем тело запроса в строку
        body = Buffer.concat(body).toString();

        if (method == "POST") {
            // Расчитываем hash и возвращаем результат
            var res = amazonSig(body);
            if ( res.err != null) {
                response.statusCode = 404;
            } else {
                response.end(JSON.stringify(res));
            }
        } else {
            response.end("OK");
        }
    });

}).listen(3000);
